local mad = require("MoonAdditions")
local timer = 0
local isComplete = false
local dt = 1 / 60
function resetPosition()
    setInteriorVisible(4)
    setPlayerControl(PLAYER_HANDLE, false)
    setCharCoordinates(PLAYER_PED, -266.095886, 0.209114, 1244.833252)
    setCharHeading(PLAYER_PED, 270)
    setCameraBehindPlayer()
    wait(10)
    restoreCameraJumpcut()
    setPlayerControl(PLAYER_HANDLE, true)
    timer = 0
    isComplete = false
end

function isPlayerAtSpawn()
    return isCharInArea3d(PLAYER_PED, -263.209412, 27.805998, 1244.833252, -273.094788, -26.850069, 1265.833252, false)
end

function isPlayerAtEnd()
    return isCharInArea3d(PLAYER_PED, -272.712677, 19.304399, 882.444092, -263.627808, -18.594728, 882.444092, false)
end

function main()
    printHelpString("SASurf v1.0")
    while true do
        wait(0)
        if isPlayerControllable(PLAYER_HANDLE) then
            if isKeyJustPressed(0x52) then
                resetPosition()
            end
        end

        if not isPlayerAtSpawn() and not isComplete then
            timer = timer + dt
        end

        if isPlayerAtEnd() and not isComplete then
            isComplete = true
        end
        
        mad.draw_text(string.format("%.3f", timer), 0, 0)
    end
end
